#include <windows.h>
#include <string>
#include <list>
#include "fst/FST.h"
#include "fst/FSTDynamicClass.h"

#define FST_API extern "C" __declspec(dllexport)

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

FST_API void* WINAPI FstPocketCompilerNew(
    const char* mcpFile, const char* lFile, const char* l2sFiles)
    // l2sFiles can be comma-separated list of files
{
    return new FSTPocketCompiler(mcpFile, lFile, l2sFiles);
}

FST_API void  WINAPI FstPocketCompilerDelete(void* h)
{
    delete reinterpret_cast<FSTPocketCompiler*>(h);
}

FST_API void* WINAPI FstPocketCompilerJsgfCompile(void* h, const char* jsgf)
{
    return reinterpret_cast<FSTPocketCompiler*>(h)->jsgfCompile(jsgf);
}

FST_API void* WINAPI FstPocketCompilerJsgfCompileClass(void* h, const char* className, const char* jsgf)
{
    return reinterpret_cast<FSTPocketCompiler*>(h)->jsgfCompileClass(className, jsgf);
}

FST_API void* WINAPI FstPocketCompilerListCompileClass(void* h, const char* className, const char* phrases)
    // phrases are comma-separated
{
    return reinterpret_cast<FSTPocketCompiler*>(h)->listCompileClass(className, phrases);
}

FST_API void  WINAPI FstMemoryIncRef(void* h)
{
    reinterpret_cast<ReferenceCountedMemory*>(h)->incref();
}

FST_API void  WINAPI FstMemoryDecRef(void* h)
{
    reinterpret_cast<ReferenceCountedMemory*>(h)->decref();
}

