/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse FSTJsgf_yyparse
#define yylex   FSTJsgf_yylex
#define yyerror FSTJsgf_yyerror
#define yylval  FSTJsgf_yylval
#define yychar  FSTJsgf_yychar
#define yydebug FSTJsgf_yydebug
#define yynerrs FSTJsgf_yynerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     HEADER = 258,
     GRAMMAR = 259,
     IMPORT = 260,
     PUBLIC = 261,
     NULL_TOKEN = 262,
     VOID_TOKEN = 263,
     IMPORT_NAME = 264,
     RULE_NAME = 265,
     TOKEN = 266,
     TAG = 267,
     ERROR = 268,
     WEIGHT = 269
   };
#endif
/* Tokens.  */
#define HEADER 258
#define GRAMMAR 259
#define IMPORT 260
#define PUBLIC 261
#define NULL_TOKEN 262
#define VOID_TOKEN 263
#define IMPORT_NAME 264
#define RULE_NAME 265
#define TOKEN 266
#define TAG 267
#define ERROR 268
#define WEIGHT 269




/* Copy the first part of user declarations.  */
#line 44 "FSTJsgfParser.ypp"


#include "fst/FST.h"
#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cmath>
#include "fst/format.h"

#ifdef DEBUG
    //#define YYDBUG 1
#endif

using namespace std;

typedef fst::vector<FSTGeneric> FstVector;
typedef fst::map<int, FstVector> IntListMap;
typedef fst::list<int> IntList;
typedef fst::map<int, FSTGeneric> IntFstMap;
typedef fst::set<int> IntSet;

// See comment in configure.ac
#ifdef HAVE_CONFIG_H
#include "config.h"
#ifdef HAVE_YYFLEXLEXER_YYWRAP
inline int yyFlexLexer::yywrap(){return 1;}
#endif
#endif

struct FSTJsgf_yy : public yyFlexLexer {
    string filename;
    int  line;

    int yylex();
    bool parse(istream& is, const string& filename,
               FSTGeneric& result, string& error_msg,
               bool ignore_tags, bool ignore_words, bool rtn_parse, 
               bool pause12, bool allow_recursion);

    fst::set<int>   _public;
    IntListMap table;
    FSTGeneric _result;
    bool       ignore_tags;
    bool       ignore_words;
    bool       rtn_parse;
    bool       pause12;
    bool       allow_recursion;
    ostringstream error_os;
    IntList    recursion;

    void       finish_grammar();
    void       finish_expression(FstVector* plist);
    void       rule(int rule_name, FstVector* plist);
    FSTGeneric empty();
    FSTGeneric _void();
    FSTGeneric simple(int input, int output);
    FSTGeneric series(FstVector* fsts, float weight=-1);
    FSTGeneric parallel(FstVector* fsts);
    FSTGeneric optimize(const FSTGeneric& x);
    bool detect_recursion(IntFstMap& nonterminal_map, IntSet& busy, int label);
    void reset();
};

static int yylex(FSTJsgf_yy *parser)
{
    return parser->yylex();
}

static int yyerror(FSTJsgf_yy *parser, const char* msg, bool no_before=false);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 117 "FSTJsgfParser.ypp"
{
    int label;
    float weight;
    FSTGeneric* fst;
    fst::vector<FSTGeneric>* fst_list;
}
/* Line 187 of yacc.c.  */
#line 212 "FSTJsgfParser.cpp"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 225 "FSTJsgfParser.cpp"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  23
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   72

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  24
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  12
/* YYNRULES -- Number of rules.  */
#define YYNRULES  30
/* YYNRULES -- Number of states.  */
#define YYNSTATES  51

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   269

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      20,    21,    18,    19,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    15,
       2,    16,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    22,     2,    23,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    17,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     8,    10,    11,    14,    18,    20,    23,
      29,    34,    36,    38,    40,    44,    47,    52,    54,    57,
      59,    62,    65,    67,    69,    71,    75,    79,    81,    83,
      85
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      25,     0,    -1,     3,     4,    26,    28,    -1,    30,    -1,
      -1,    26,    27,    -1,     5,     9,    15,    -1,    29,    -1,
      28,    29,    -1,     6,    10,    16,    30,    15,    -1,    10,
      16,    30,    15,    -1,    31,    -1,    32,    -1,    33,    -1,
      31,    17,    33,    -1,    14,    33,    -1,    32,    17,    14,
      33,    -1,    34,    -1,    34,    33,    -1,    35,    -1,    35,
      18,    -1,    35,    19,    -1,    12,    -1,     7,    -1,     8,
      -1,    20,    30,    21,    -1,    22,    30,    23,    -1,    11,
      -1,    10,    -1,     6,    -1,     5,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   157,   157,   162,   169,   169,   173,   181,   181,   185,
     191,   198,   203,   210,   217,   226,   233,   242,   249,   258,
     260,   267,   288,   298,   304,   312,   319,   326,   332,   338,
     345
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "HEADER", "GRAMMAR", "IMPORT", "PUBLIC",
  "NULL_TOKEN", "VOID_TOKEN", "IMPORT_NAME", "RULE_NAME", "TOKEN", "TAG",
  "ERROR", "WEIGHT", "';'", "'='", "'|'", "'*'", "'+'", "'('", "')'",
  "'['", "']'", "$accept", "start", "import_list", "import", "rule_list",
  "rule", "expr_plist", "expr_plistu", "expr_plistw", "expr_slist",
  "expr_item", "expr_item_k", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,    59,    61,   124,    42,    43,
      40,    41,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    24,    25,    25,    26,    26,    27,    28,    28,    29,
      29,    30,    30,    31,    31,    32,    32,    33,    33,    34,
      34,    34,    34,    34,    34,    35,    35,    35,    35,    35,
      35
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     4,     1,     0,     2,     3,     1,     2,     5,
       4,     1,     1,     1,     3,     2,     4,     1,     2,     1,
       2,     2,     1,     1,     1,     3,     3,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,    30,    29,    23,    24,    28,    27,    22,     0,
       0,     0,     0,     3,    11,    12,    13,    17,    19,     4,
      15,     0,     0,     1,     0,     0,    18,    20,    21,     0,
      25,    26,    14,     0,     0,     0,     0,     5,     2,     7,
      16,     0,     0,     0,     8,     6,     0,     0,     0,    10,
       9
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    12,    29,    37,    38,    39,    13,    14,    15,    16,
      17,    18
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -11
static const yytype_int8 yypact[] =
{
       1,    -1,   -11,   -11,   -11,   -11,   -11,   -11,   -11,    50,
      32,    32,     5,   -11,    12,    13,   -11,    50,     9,   -11,
     -11,    -5,     2,   -11,    50,    17,   -11,   -11,   -11,    14,
     -11,   -11,   -11,    50,    23,    24,     6,   -11,     8,   -11,
     -11,    20,    25,    32,   -11,   -11,    32,    30,    33,   -11,
     -11
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -11,   -11,   -11,   -11,   -11,    11,   -10,   -11,   -11,    -7,
     -11,   -11
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      21,    22,    20,    19,     1,    23,     2,     3,     4,     5,
      26,     6,     7,     8,    35,     9,    30,    32,    36,    34,
      35,    10,    43,    11,    36,    31,    40,    27,    28,    24,
      25,    33,    41,    47,    42,    45,    48,     2,     3,     4,
       5,    46,     6,     7,     8,    49,     9,     0,    50,    44,
       0,     0,    10,     0,    11,     2,     3,     4,     5,     0,
       6,     7,     8,     0,     0,     0,     0,     0,     0,     0,
      10,     0,    11
};

static const yytype_int8 yycheck[] =
{
      10,    11,     9,     4,     3,     0,     5,     6,     7,     8,
      17,    10,    11,    12,     6,    14,    21,    24,    10,     5,
       6,    20,    16,    22,    10,    23,    33,    18,    19,    17,
      17,    14,     9,    43,    10,    15,    46,     5,     6,     7,
       8,    16,    10,    11,    12,    15,    14,    -1,    15,    38,
      -1,    -1,    20,    -1,    22,     5,     6,     7,     8,    -1,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      20,    -1,    22
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     5,     6,     7,     8,    10,    11,    12,    14,
      20,    22,    25,    30,    31,    32,    33,    34,    35,     4,
      33,    30,    30,     0,    17,    17,    33,    18,    19,    26,
      21,    23,    33,    14,     5,     6,    10,    27,    28,    29,
      33,     9,    10,    16,    29,    15,    16,    30,    30,    15,
      15
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (parser, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex (parser)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, parser); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, FSTJsgf_yy *parser)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, parser)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    FSTJsgf_yy *parser;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (parser);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, FSTJsgf_yy *parser)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, parser)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    FSTJsgf_yy *parser;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, parser);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, FSTJsgf_yy *parser)
#else
static void
yy_reduce_print (yyvsp, yyrule, parser)
    YYSTYPE *yyvsp;
    int yyrule;
    FSTJsgf_yy *parser;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , parser);
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, parser); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, FSTJsgf_yy *parser)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, parser)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    FSTJsgf_yy *parser;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (parser);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (FSTJsgf_yy *parser);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (FSTJsgf_yy *parser)
#else
int
yyparse (parser)
    FSTJsgf_yy *parser;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 158 "FSTJsgfParser.ypp"
    {
    parser->finish_grammar();
;}
    break;

  case 3:
#line 163 "FSTJsgfParser.ypp"
    {
    parser->finish_expression((yyvsp[(1) - (1)].fst_list));
;}
    break;

  case 6:
#line 174 "FSTJsgfParser.ypp"
    {
    parser->error_os << parser->filename << ':' << parser->line <<
        ": warning: import not implemented\n";
;}
    break;

  case 9:
#line 186 "FSTJsgfParser.ypp"
    {
    parser->_public.insert((yyvsp[(2) - (5)].label));
    parser->rule((yyvsp[(2) - (5)].label), (yyvsp[(4) - (5)].fst_list));
;}
    break;

  case 10:
#line 192 "FSTJsgfParser.ypp"
    {
    parser->rule((yyvsp[(1) - (4)].label), (yyvsp[(3) - (4)].fst_list));
;}
    break;

  case 11:
#line 199 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = (yyvsp[(1) - (1)].fst_list);
;}
    break;

  case 12:
#line 204 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = (yyvsp[(1) - (1)].fst_list);
;}
    break;

  case 13:
#line 211 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = new FstVector;
    (yyval.fst_list)->push_back(parser->series((yyvsp[(1) - (1)].fst_list)));
    delete (yyvsp[(1) - (1)].fst_list);
;}
    break;

  case 14:
#line 218 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = (yyvsp[(1) - (3)].fst_list);
    (yyval.fst_list)->push_back(parser->series((yyvsp[(3) - (3)].fst_list)));
    delete (yyvsp[(3) - (3)].fst_list);
;}
    break;

  case 15:
#line 227 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = new FstVector;
    (yyval.fst_list)->push_back(parser->series((yyvsp[(2) - (2)].fst_list), (yyvsp[(1) - (2)].weight)));
    delete (yyvsp[(2) - (2)].fst_list);
;}
    break;

  case 16:
#line 234 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = (yyvsp[(1) - (4)].fst_list);
    (yyval.fst_list)->push_back(parser->series((yyvsp[(4) - (4)].fst_list), (yyvsp[(3) - (4)].weight)));
    delete (yyvsp[(4) - (4)].fst_list);
;}
    break;

  case 17:
#line 243 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = new FstVector;
    (yyval.fst_list)->push_back(*(yyvsp[(1) - (1)].fst));
    delete (yyvsp[(1) - (1)].fst);
;}
    break;

  case 18:
#line 250 "FSTJsgfParser.ypp"
    {
    (yyval.fst_list) = (yyvsp[(2) - (2)].fst_list);
    (yyval.fst_list)->push_back(*(yyvsp[(1) - (2)].fst));
    delete (yyvsp[(1) - (2)].fst);
;}
    break;

  case 20:
#line 261 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = FSTClosure(*(yyvsp[(1) - (2)].fst), false);
    delete (yyvsp[(1) - (2)].fst);
;}
    break;

  case 21:
#line 268 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = FSTClosure(*(yyvsp[(1) - (2)].fst), true);
    delete (yyvsp[(1) - (2)].fst);
;}
    break;

  case 22:
#line 289 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    if (parser->ignore_tags) {
        *(yyval.fst) = parser->empty();
    } else {
        *(yyval.fst) = parser->simple(0, (yyvsp[(1) - (1)].label));
    }
;}
    break;

  case 23:
#line 299 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->empty();
;}
    break;

  case 24:
#line 305 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->_void();
;}
    break;

  case 25:
#line 313 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->parallel((yyvsp[(2) - (3)].fst_list));
    delete (yyvsp[(2) - (3)].fst_list);
;}
    break;

  case 26:
#line 320 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = FSTUnion(parser->empty(), parser->parallel((yyvsp[(2) - (3)].fst_list)));
    delete (yyvsp[(2) - (3)].fst_list);
;}
    break;

  case 27:
#line 327 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->simple((yyvsp[(1) - (1)].label), (yyvsp[(1) - (1)].label));
;}
    break;

  case 28:
#line 333 "FSTJsgfParser.ypp"
    {
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->simple((yyvsp[(1) - (1)].label), (yyvsp[(1) - (1)].label));
;}
    break;

  case 29:
#line 339 "FSTJsgfParser.ypp"
    {
    int i = FSTstring_map["public"];
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->simple(i, i);
;}
    break;

  case 30:
#line 346 "FSTJsgfParser.ypp"
    {
    int i = FSTstring_map["import"];
    (yyval.fst) = new FSTGeneric;
    *(yyval.fst) = parser->simple(i, i);
;}
    break;


/* Line 1267 of yacc.c.  */
#line 1671 "FSTJsgfParser.cpp"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (parser, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (parser, yymsg);
	  }
	else
	  {
	    yyerror (parser, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, parser);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, parser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (parser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, parser);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, parser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 352 "FSTJsgfParser.ypp"


static int
yyerror(FSTJsgf_yy *parser, const char* msg, bool no_before)
{
    if (!no_before) {
        string token;
        switch (yychar) {
        case HEADER:
            token = "`#JSGF'";
            break;
        case GRAMMAR:
            token = "`grammar'";
            break;
        case IMPORT:
            token = "`import'";
            break;
        case PUBLIC:
            token = "`public'";
            break;
        case NULL_TOKEN:
            token = "`<NULL>'";
            break;
        case VOID_TOKEN:
            token = "`<VOID>'";
            break;
        case ERROR:
        case RULE_NAME:
        case TOKEN:
            token = "`";
            token += FSTstring_map[yylval.label];
            token += "'";
            break;
        case TAG:
            token = "`{";
            token += FSTstring_map[yylval.label];
            token += "}'";
            break;
        case WEIGHT:
            token = "`/'";
            break;
        case 0:
            token = "end of file";
            break;
        default:
            token += "`";
            token += char(yychar);
            token += "'";
            break;
        }
        if (token.size()) {
            parser->error_os << parser->filename << ':' << parser->line <<
                ": " << msg << " before " << token << '\n';
            return 0;
        }
    }
    parser->error_os << parser->filename << ':' << parser->line <<
        ": " << msg << '\n';
    return 0;
}

bool
FSTJsgf_yy::detect_recursion(IntFstMap& nonterminal_map, IntSet& busy, int label)
{
    if (busy.count(label)) {
        recursion.push_front(label);
        return true;
    }
    busy.insert(label);
    const IntSet labels = nonterminal_map[label]->input_alphabet();
    for (IntSet::const_iterator i = labels.begin(); i != labels.end(); i++) {
        int l = (*i);
        if (nonterminal_map.count(l)) {
            if (detect_recursion(nonterminal_map, busy, l)) {
                recursion.push_front(label);
                return true;
            }
        }
    }
    busy.erase(label);
    return false;
}

void
FSTJsgf_yy::finish_grammar()
{
    // Construct root FST, which is union of all public rules.
    //
    FSTGeneric root = FSTBasic();
    root->add_states(2);
    root->set_initial(0);
    for (fst::set<int>::iterator i = _public.begin();
         i != _public.end(); ++i) {
        root->add_arc(0, 1, *i, ignore_words ? 0 : *i);
    }
    root->set_final(1);
    if (pause12) {
        int pause1 = FSTstring_map["<pause1>"];
        int pause2 = FSTstring_map["<pause2>"];
        root->add_states(2);
        root->set_initial(2);
        root->add_arc(2, 0, pause1, ignore_words ? 0 : pause1);
        root->add_arc(1, 3, pause2, ignore_words ? 0 : pause2);
        root->clear_final(1);
        root->set_final(3);
    }

    // Construct all nonterminal FSTs.  While doing so, check that they do not
    // refer to a rule that wasn't defined.
    //
    FstVector nonterminal_fsts;
    fst::vector<string> nonterminals;
    IntFstMap nonterminal_map;
    for (IntListMap::iterator i = table.begin();
	 i != table.end(); ++i) {
	int label = (*i).first;
        FstVector& fsts = (*i).second;

	FSTGeneric fst = optimize(parallel(&fsts));

        const fst::set<int>& alphabet = fst->input_alphabet();
        for (fst::set<int>::const_iterator j = alphabet.begin();
             j != alphabet.end(); ++j) {
            const char* l = FSTstring_map[*j];
            if (l[0] == '<' && table.count(*j) == 0)
                error_os << "warning: rule " << FSTstring_map[label]
                          << " refers to undefined rule " << l << '\n';
        }

        nonterminal_fsts.push_back(fst);
        nonterminals.push_back(FSTstring_map[label]);
        nonterminal_map[label] = fst;
    }

    if (!allow_recursion) {
        IntSet busy;
        recursion.clear();
        for (IntFstMap::iterator i = nonterminal_map.begin(); i != nonterminal_map.end(); i++) {
            int label = (*i).first;
            if (detect_recursion(nonterminal_map, busy, label)) {
                _result = FSTBasic();
                error_os.str("");
                error_os << "recursion:";
                for (IntList::iterator j = recursion.begin(); j != recursion.end(); j++) {
                    error_os << ' ' << FSTstring_map[*j];
                }
                error_os << '\n';
                return;
            }
        }
    }

    _result = FSTRtn(root, nonterminals, nonterminal_fsts, rtn_parse);
}

void
FSTJsgf_yy::finish_expression(FstVector* plist)
{
    _result = optimize(parallel(plist));
    delete plist;
}

void
FSTJsgf_yy::rule(int rule_name, FstVector* plist)
{
    if (table.count(rule_name))
        error_os << "warning: merging extra definition of rule "
                  << FSTstring_map[rule_name] << ", line "
                  << line << '\n';
    FstVector& entry = table[rule_name];
    entry.insert(entry.end(), plist->begin(), plist->end());
    delete plist;
}

FSTGeneric
FSTJsgf_yy::empty()
{
    FSTGeneric result = FSTBasic();
    result->add_state();
    result->set_initial(0);
    result->set_final(0);
    return result;
}

FSTGeneric
FSTJsgf_yy::_void()
{
    FSTGeneric result = FSTBasic();
    result->add_state();
    result->set_initial(0);
    return result;
}

FSTGeneric
FSTJsgf_yy::simple(int input, int output)
{
    FSTGeneric result = FSTBasic();
    result->add_states(2);
    result->set_initial(0);
    result->set_final(1);
    if (ignore_words && input)
        result->add_arc(0, 1, input, 0);
    else
        result->add_arc(0, 1, input, output);
    return result;
}

FSTGeneric
FSTJsgf_yy::series(FstVector* fsts, float weight)
{
    FSTGeneric result;
    switch (fsts->size()) {
    case 0:
        result = empty();
        break;
    case 1:
        result = FSTBasic(fsts->front());
        result->set_potential(result->initial(), weight);
        break;
    default:
        reverse(fsts->begin(), fsts->end());
        result = FSTBasic(FSTConcatenate(*fsts));
        result->set_potential(result->initial(), weight);
        break;
    }
    return result;
}

FSTGeneric
FSTJsgf_yy::parallel(FstVector* fsts)
{
    assert(fsts->size() > 0);
    if (fsts->size() == 1) {
        FSTGeneric& fst = fsts->front();
        if (fst->potential(fst->initial()) == 0) {
            return _void();
        } else {
            fst->set_potential(fst->initial(), FSTMinPlus->one);
            return FSTBasic(fst);
        }
    } else {
        float total_weight = 0;
        for (FstVector::iterator i = fsts->begin(); i != fsts->end(); i++) {
            FSTGeneric& fst = *i;
            float w = fst->potential(fst->initial());
            if (w < 0) {
                total_weight = -1;
                break;
            }
            total_weight += w;
        }
        if (total_weight == -1) {
            // No weights were specified in JSGF, so no weights in FST.
            return FSTBasic(FSTUnion(*fsts));

        } else if (total_weight == 0) {
            // Weights were specified in JSGF, and they sum to 0.
            return _void();
        } else {
            // Weights were specified in JSGF, normalize to sum to 1.
            float log_total = logf(total_weight);
            fst::vector<float> weights;
            weights.reserve(fsts->size());
            for (FstVector::iterator i = fsts->begin(); i != fsts->end(); i++) {
                FSTGeneric& fst = *i;
                float w = fst->potential(fst->initial());
                if (w == 0) {
                    fsts->erase(i--);
                } else {
                    weights.push_back(log_total - logf(w));
                }
            }
            return FSTBasic(FSTUnion(*fsts, weights));
        }
    }
}

FSTGeneric
FSTJsgf_yy::optimize(const FSTGeneric& x)
{
    if (x->n_states() > 0)
        return FSTOptimizeA(x);
    else
        return x;
}

void
FSTJsgf_yy::reset()
{
    _public.clear();
    table.clear();
    _result = FSTBasic();
    error_os.str("");
    recursion.clear();
}

bool
FSTJsgf_yy::parse(istream& is, const string& filename,
                  FSTGeneric& result, string& error_msg,
                  bool ignore_tags, bool ignore_words, bool rtn_parse, 
                  bool pause12, bool allow_recursion)
{
#if YYDEBUG
    char *e = getenv("YYDEBUG");
    yydebug = e ? atoi(e) : 0;
#endif
    yyin = &is;
    this->filename = filename;
    this->line = 1;
    this->ignore_tags = ignore_tags;
    this->ignore_words = ignore_words;
    this->rtn_parse = rtn_parse;
    this->pause12 = pause12;
    this->allow_recursion = allow_recursion;
    reset();
    bool success = (yyparse(this) == 0) && (allow_recursion || recursion.empty());
    if (success){
        result = _result;
    } else {
        error_msg = error_os.str();
    }
    reset();
    return success;
}

bool
FSTJsgfParseFile(FSTGeneric& result, const string& filename,
                 bool ignore_tags, bool ignore_words, bool rtn_parse, bool pause12,
                 bool allow_recursion)
{
    FSTJsgf_yy parser;
    bool success;
    string error_msg;
    if (filename == "-") {
        success = parser.parse(cin, "stdin",
                               result, error_msg,
                               ignore_tags, ignore_words, rtn_parse, pause12,
                               allow_recursion);
    } else {
        ifstream is(filename.c_str());
        if (!is){
            FSTFatal("can't read file `%s'", filename.c_str());
        }
        success = parser.parse(is, filename,
                               result, error_msg,
                               ignore_tags, ignore_words, rtn_parse, pause12,
                               allow_recursion);
    }
    if (!success) {
        cerr << error_msg;
    }
    return success;
}

bool
FSTJsgfParseString(FSTGeneric& result, string& error_msg, const char* input,
                   bool ignore_tags, bool ignore_words, bool rtn_parse, bool pause12,
                   bool allow_recursion)
{
    FSTJsgf_yy parser;
    istringstream is(input);
    return parser.parse(is, "line",
                        result, error_msg,
                        ignore_tags, ignore_words, rtn_parse, pause12,
                        allow_recursion);
}

// for Emacs...
// Local Variables:
// mode: C++
// comment-column: 48
// fill-column: 79
// indent-tabs-mode: nil
// c-basic-offset: 4
// End:

