#include <unistd.h>

char *optarg;
int optind, opterr, optopt;

static int _argc, _argi;
static char * const * _argv;
static const char *_argp;

int getopt(int argc, char * const argv[],  const char *optstring)
{
    const char *optp;
    
    if (argv != _argv || argc != _argc) {
        _argv = argv;
        _argc = argc;
        _argi = 0;
        _argp = 0;
    }

    if (_argp == 0 || *_argp == 0) {
        if (_argi++ == _argc) {
            optind = _argc;
            return -1;
        }
        _argp = _argv[_argi];
        if (_argp == 0 || _argp[0] != '-' || _argp[1] == 0) {
            optind = _argi;
            return -1;
        }
        _argp++;
    }

    for (optp = optstring; *optp; optp++) {
        if (optp[0] == _argp[0]) {
            if (optp[1] == ':') {
                if (_argp[1]) {
                    optarg = (char*)(_argp + 1);
                } else {
                    optarg = _argv[++_argi];
                    if (optarg == 0)
                        return ':';
                }
                _argp = 0;
            } else {
                optarg = 0;
                _argp++;
            }
            return optp[0];
        } else if (optp[1] == ':') {
            optp++;
        }
    }

    return '?';
}
