////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005, Massachusetts Institute of Technology              //
// All rights reserved.                                                   //
//                                                                        //
// Redistribution and use in source and binary forms, with or without     //
// modification, are permitted provided that the following conditions are //
// met:                                                                   //
//                                                                        //
//     * Redistributions of source code must retain the above copyright   //
//       notice, this list of conditions and the following disclaimer.    //
//                                                                        //
//     * Redistributions in binary form must reproduce the above          //
//       copyright notice, this list of conditions and the following      //
//       disclaimer in the documentation and/or other materials provided  //
//       with the distribution.                                           //
//                                                                        //
//     * Neither the name of the Massachusetts Institute of Technology    //
//       nor the names of its contributors may be used to endorse or      //
//       promote products derived from this software without specific     //
//       prior written permission.                                        //
//                                                                        //
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS    //
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT      //
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR  //
// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT   //
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,  //
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT       //
// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,  //
// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY  //
// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT    //
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE  //
// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.   //
////////////////////////////////////////////////////////////////////////////

#ifndef __fst_windows_h__
#define __fst_windows_h__

#ifdef _MSC_VER

#if 0
#define Arc MSC_Arc
#include <windows.h>
#undef  Arc
#ifdef ERROR
#  undef ERROR
#endif
#endif

extern "C" char *strtok_r(char *in, const char *delims, char **save);

// Dummy define.
//
#define __GNUC_PREREQ(x,y) 0

// Make for variable scoping compliant with C++ standard.
//
#if _MSC_VER < 9
#ifndef for
#  define for if(false); else for
#endif
#endif

// Silence select warnings.
//
#pragma warning(disable: 4018) // signed/unsigned mismatch
#pragma warning(disable: 4065) // switch statement with default but no case
#pragma warning(disable: 4200) // zero-sized array in struct/union
#pragma warning(disable: 4244) // conversion from double to float
#pragma warning(disable: 4800) // conversion from int to bool
#pragma warning(disable: 4996) // strdup

#if 0
#pragma warning(disable: 4305)
#pragma warning(disable: 4786)
#endif

#endif // _MSC_VER


#endif // __fst_windows_h__
