#include <fstream>
#include <cstring>
#include "fst/FST.h"

using namespace std;

FSTMemory::FSTMemory(const void* data, unsigned size, unsigned alignment)
{
    _size = size;
    _alloc = new char[size];
    if (long(_alloc) & ~long(alignment - 1)) {
        delete[] _alloc;
        _alloc = new char[size + alignment - 1];
        _base = (void*)((long(_alloc) + alignment - 1) & ~long(alignment - 1));
    } else {
        _base = _alloc;
    }
    memcpy(_base, data, _size);
}

FSTMemory::~FSTMemory()
{
    delete[] _alloc;
}

void
FSTMemory::dump(const char* filename) const
{
    ofstream os(filename, ios_base::binary);
    os.write(reinterpret_cast<const char*>(base()), size());
}
