/*
  Converted to C++ by I. Lee Hetherington <ilh@csail.mit.edu>.

  Copyright (C) 1999, 2002 Aladdin Enterprises.  All rights reserved.

  This software is provided 'as-is', without any express or implied
  warranty.  In no event will the authors be held liable for any damages
  arising from the use of this software.

  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

  L. Peter Deutsch
  ghost@aladdin.com

 */

#ifndef __MD5_h__
#define __MD5_h__

class MD5 {

public:
    typedef unsigned char uint8;
    typedef unsigned int uint32;

    MD5();
    void reset();
    void hash(const uint8* bytes, uint32 nBytes);
    void finish(uint8 digest[16]);

private:
    uint32 count[2];    // message length in bits, LSW first
    uint32 abcd[4];     // digest buffer
    uint8  buf[64];     // accumulate block

    void process(const uint8* data);
};

#endif /* __MD5_h__ */
