#include <cstring>
#include <vector>
#include <deque>
#include <algorithm>
#include <cmath>
#include <vector>
#include <deque>
#include "sq.h"

using namespace std;

ScalarQuantizerTrainer::~ScalarQuantizerTrainer()
{
}

void
ScalarQuantizerTrainer::incorporate(float x, float weight)
{
    data.push_back(FloatFloat(x, weight));
}

void
ScalarQuantizerTrainer::incorporate(const float* begin, const float* end, float weight)
{
    for (const float* p = begin; p < end; ++p) {
        data.push_back(FloatFloat(*p, weight));
    }
}

void
sq_trainer_delete(void* trainer)
{
    delete reinterpret_cast<ScalarQuantizerTrainer*>(trainer);
}

void
sq_trainer_incorporate(void* trainer, float x, float weight)
{
    reinterpret_cast<ScalarQuantizerTrainer*>(trainer)->incorporate(x, weight);
}

void
sq_trainer_incorporate_sequence(void* trainer, const float* begin, const float* end, float weight)
{
    reinterpret_cast<ScalarQuantizerTrainer*>(trainer)->incorporate(begin, end, weight);
}

void
sq_trainer_train(void* trainer, float** pd, float** pr)
{
    vector<float> dv, rv;
    reinterpret_cast<ScalarQuantizerTrainer*>(trainer)->train(dv, rv);
    *pd = (float*) malloc(dv.size()*sizeof(float));
    memcpy(*pd, &dv[0], dv.size()*sizeof(float));
    *pr = (float*) malloc(rv.size()*sizeof(float));
    memcpy(*pr, &rv[0], rv.size()*sizeof(float));
}

unsigned
sq_quantize(float x, const float* d, unsigned n)
{
    int len = n - 1;
    int first = 0;
    while (len > 0) {
        int half = len/2;
        int middle = first + half;
        if (d[middle] <= x) {
            first = middle + 1;
            len -= half + 1;
        } else {
            len = half;
        }
    }
    return first;
}
