// -*- C++ -*-

#ifndef __fst_h__
#define __fst_h__

#include "fst/FST.h"
#include <string>

class FstTool;
extern FstTool* fst_tool_list;

class FstTool {

    typedef int (*FunctionPtr)(int argc, char** argv);
    std::string _name;
    FunctionPtr _pfunc;
    FstTool* _next;

public:
    FstTool(const char* name, FunctionPtr pfunc)
        : _name(name), _pfunc(pfunc) {
        _next = fst_tool_list;
        fst_tool_list = this;
    }

    FstTool* next() {
        return _next;
    }

    std::string name() const {
        return _name;
    }

    void help() const {
        _pfunc(-1, NULL);
    }

    int run(int argc, char** argv) {
        return _pfunc(argc, argv);
    }

};

#ifdef _MSC_VER
extern "C" {
extern int getopt(int argc, char * const argv[],  const char *optstring);
extern char* optarg;
extern int optind, opterr, optopt;
}
#endif


#endif //  __fst_h__
