/* -*- C++ -*-
 *
 * Copyright (c) 2006
 * Spoken Language Systems Group
 * MIT Computer Science and Artificial Intelligence Laboratory
 * Massachusetts Institute of Technology
 *
 * All Rights Reserved
 */
#include <iostream>
#include "fst.h"

using namespace std;

static void
usage()
{
    cerr << "usage: fst quantize_weights bits in.fst out.fst\n\n";
}

static int
fst_quantize_weights(int argc, char** argv)
{
    argc--;
    argv++;

    if (argc != 3) {
    usage();
        return 1;
    }

    int bits = atoi(*argv++);
    const char* in_file  = *argv++;
    const char* out_file = *argv++;

    FSTGeneric x = FSTLoad(in_file);
    FSTQuantizeWeights(bits, x)->dump_binary(out_file);

    return 0;
}

// Register as subcommand.
//
static FstTool quantize_weights_tool("quantize_weights", fst_quantize_weights);

// for Emacs...
// Local Variables:
// mode: C++
// comment-column: 48
// fill-column: 80
// c-basic-offset: 4
// indent-tabs-mode: nil
// End:


