#!/usr/bin/perl

$fst_home = shift;
$arch = shift;

$fst_home = $ENV{"FST_HOME"} if $fst_home eq "";
$arch = $ENV{"HOSTTYPE"} if $arch eq "";

$fst_home =~ s/\./\\\./g;	# escape `.' because of use in regular expression

$max_ch = 70;			# Max # chars on a given line

@deps = <STDIN>;		# Read rest in all at once
$_ = join(' ', @deps);

				# Make each entry one line, remove the parent directories
s%\\\n%%g;

@deps = split('\n', $_);

foreach $dep (@deps) {

  $dep =~ s/^\s+//g;		# Remove leading/trailing whitespace
  $dep =~ s/\s+$//g;
  $dep =~ s/\s+/ /g;		# Map multiple spaces to a single one

				# Put FST_HOME back into dependency list
  if ($fst_home ne "") {
    $dep =~ s%$fst_home%\$\(FST_HOME\)%g;
  }

  @entries = split(' ', $dep);	# Loop through them individually


  $tag = $entries[0];

  if ($arch ne "next") {
    chop($tag);
  }

  if ($entries[1] =~ /\/.*$/) {
    $subdir = $entries[1];
    $subdir =~ s/\/[^\/]*$//;
    $out = "\$(OBJ_DIR_N)$subdir/$tag \$(OBJ_DIR_D)$subdir/$tag \$(OBJ_DIR_P)$subdir/$tag:";
  }
  else {
    $out = "\$(OBJ_DIR_N)$tag \$(OBJ_DIR_D)$tag \$(OBJ_DIR_P)$tag:";
  }

  $tabbing = "        ";

  $len = length($out);

  if ($arch eq "next") {
    $entries[1] = $tag;
    chop($entries[1]);
    $entries[1] .= "c";
  }

  foreach $i (1..@entries) {
    $len += length($entries[$i])+1;

    if ($len > $max_ch) {
      $out .= " \\\n$tabbing";
      $len = length($tabbing);
    }

    $out .= " $entries[$i]";
  }
  print "$out\n\n";
}
