#!/bin/csh -fe

# This scripts runs an host-specific executable in a subdirectory of the
# directory in which this script lives.

set self = $0
set dir  = $self:h
set file = $self:t
if ("$dir" == "$file") set dir = .

setenv ARCH `$dir/../templates/guess-arch.csh`
setenv OS `$dir/../templates/guess-os.csh`

if (! $?ARCH || "$ARCH" == "unknown" || "$ARCH" == "") then
    unsetenv ARCH
    echo "ARCH not set in environment and couldn't automatically determine it"
endif

if ( "$OS" == "Windows_NT" ) then
    setenv OS winnt
endif

if (! $?OS || "$OS" == "unknown" || "$OS" == "") then
    unsetenv OS
    echo "OS not set in environment and couldn't automatically determine it"
endif

if (! $?ARCH || ! $?OS) then
    echo "exiting"
    exit 1
endif

# Normalize ARCH.
#
switch ($ARCH)
case i86pc:
    setenv ARCH x86
    breaksw
case ia64:
    setenv ARCH ia64
    breaksw
case x86_64:
    setenv ARCH x86_64
    breaksw
case sun4:
    setenv ARCH sparc
    breaksw
endsw

setenv ARCHOS $ARCH-$OS      

exec $dir/$ARCHOS/$file $argv:q

# for Emacs...
# Local Variables:
# mode: csh
# comment-column: 40
# fill-column: 77
# csh-indent-level: 2
# End:
