#   (c) Copyright 2003
#       Massachusetts Institute of Technology
#       Spoken Language Systems Group
#       All Rights Reserved
#

ifndef __O_MAKE__
__O_MAKE__=1

# Include system dependencies.
#
include $(FST_HOME)/templates/sysdep.make

# Compilation flags.
#
CPPFLAGS	+= -I. -I$(FST_HOME)/include -I$(NIST_HOME)/include

# Definitions for object file directories.
#
ifndef OBJ_DIR_ROOT
OBJ_DIR_ROOT = OBJ
endif

OBJ_DIR		= $(OBJ_DIR_ROOT)/$(ARCHOS)/
OBJ_DIR_N	= $(OBJ_DIR)N/
OBJ_DIR_D	= $(OBJ_DIR)D/
OBJ_DIR_P	= $(OBJ_DIR)P/
OBJ_DIR_I	= $(OBJ_DIR)I/

# Definitions turning SOURCES into lists of object files.
#
OBJ		= $(filter %.o,$(SOURCES:%.c=%.o) $(SOURCES:%.cpp=%.o) $(SOURCES:%.s=%.o))
OBJ_N		= $(OBJ:%=$(OBJ_DIR_N)%)
OBJ_D		= $(OBJ:%=$(OBJ_DIR_D)%)
OBJ_P		= $(OBJ:%=$(OBJ_DIR_P)%)
OBJ_I		= $(OBJ:%=$(OBJ_DIR_I)%)

# Set appropriate -o flag.
#
ifeq ($(OS),winnt)
    OFLAG := /Fo
else
    OFLAG := -o
endif
ifeq ($(CYGWIN),Cygwin)
    OFLAG := -o
endif

# Compilation rules for C.
#
$(OBJ_DIR_N)%.o: %.c
	-@$(MKDIR) $(dir $@)
	$(CC) -c -MMD -MP $(CFLAGS_N) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<
$(OBJ_DIR_D)%.o: %.c
	-@$(MKDIR) $(dir $@)
	$(CC) -c -MMD -MP $(CFLAGS_D) $(CFLAGS) $(CPPFLAGS) $(CPPFLAGS_D) $(OFLAG) $@ $<
$(OBJ_DIR_P)%.o: %.c
	-@$(MKDIR) $(dir $@)
	$(CC) -c -MMD -MP $(CFLAGS_P) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<
$(OBJ_DIR_I)%.o: %.c
	-@$(MKDIR) $(dir $@)
	$(INSURE_CC) -c -MMD -MP $(CFLAGS_I) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<

# Compilation rules for C++
#
$(OBJ_DIR_N)%.o: %.cpp
	-@$(MKDIR) $(dir $@)
	$(CXX) -c -MMD -MP $(CFLAGS_N) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<
$(OBJ_DIR_D)%.o: %.cpp
	-@$(MKDIR) $(dir $@)
	$(CXX) -c -MMD -MP $(CFLAGS_D) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<
$(OBJ_DIR_P)%.o: %.cpp
	-@$(MKDIR) $(dir $@)
	$(CXX) -c -MMD -MP $(CFLAGS_P) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<
$(OBJ_DIR_I)%.o: %.cpp
	-@$(MKDIR) $(dir $@)
	$(INSURE_CXX) -c -MMD -MP $(CFLAGS_I) $(CFLAGS) $(CPPFLAGS) $(OFLAG) $@ $<

# Compilation rules for assembly
#
$(OBJ_DIR_N)%.o: %.s
	-@$(MKDIR) $(dir $@)
	$(AS) $(OFLAG) $@ $<
$(OBJ_DIR_D)%.o: %.s
	-@$(MKDIR) $(dir $@)
	$(AS) $(OFLAG) $@ $<
$(OBJ_DIR_P)%.o: %.s
	-@$(MKDIR) $(dir $@)
	$(AS) $(OFLAG) $@ $<
$(OBJ_DIR_I)%.o: %.s
	-@$(MKDIR) $(dir $@)
	$(INSURE_CC) -c $(OFLAG) $@ $<

# Include source path definitions.
#
include $(FST_HOME)/templates/vpath.make

endif # ifdef __O_MAKE__

