#
#   (c) Copyright 1999
#       Massachusetts Institute of Technology
#       Spoken Language Systems Group
#       All Rights Reserved
#
# recurse.make -- relay top-level targets to all *.make files.
#
# It is done in such a way that -j will run multiple *.make files
# simultaneously.

ifndef __RECURSE_MAKE__
__RECURSE_MAKE__ = 1

default:

TARGETS =	default $(MAKECMDGOALS)

ifndef SUBMAKES
SUBMAKES	:= $(wildcard *.make)
endif

ifndef SUBDIRS
SUBDIRS		:= $(dir $(wildcard */Makefile))
endif

# Remove trailing slashes from SUBDIRS.  It complicates possible
# user dependencies.
#
override SUBDIRS := $(SUBDIRS:/=)

$(TARGETS):	$(SUBMAKES) $(SUBDIRS)

$(SUBMAKES):
		$(MAKE) -f $@ $(MAKECMDGOALS)

$(SUBDIRS):
		$(MAKE) -C $@ $(MAKECMDGOALS)

.PHONY:		default $(TARGETS) $(SUBMAKES) $(SUBDIRS)

endif # ifdef __RECURSE_MAKE__
