#!/bin/csh -f

if (! $?FST_HOME) then
    echo 'internal error: $FST_HOME must be set'
    exit 1
endif

# Make sure that ARCH and OS are set.  We compute them if necessary, but
# that is slower.

if ((! $?ARCH || ! $?OS) && -f /usr/local/lib/arch_os) then
    source /usr/local/lib/arch_os
endif

if (! $?ARCH  && -f $FST_HOME/templates/guess-arch.csh) then
    setenv ARCH `$FST_HOME/../templates/guess-arch.csh`
endif

if (! $?OS  && -f $FST_HOME/templates/guess-os.csh) then
    setenv OS `$FST_HOME/../templates/guess-os.csh`
endif

if ( "$OS" == "Windows_NT" ) then
    setenv OS winnt
endif

if (! $?ARCH || "$ARCH" == "unknown" || "$ARCH" == "") then
    unsetenv ARCH
    echo "ARCH not set in environment and couldn't automatically determine it"
endif

if (! $?OS || "$OS" == "unknown" || "$OS" == "") then
    unsetenv OS
    echo "OS not set in environment and couldn't automatically determine it"
endif

if (! $?ARCH || ! $?OS) then
    echo "exiting"
    exit 1
endif

# Normalize ARCH.
#
switch ($ARCH)
case i86pc:
    setenv ARCH x86
    breaksw
case sun4:
    setenv ARCH sparc
    breaksw
endsw

setenv ARCHOS $ARCH-$OS      
